
// Copyright, Finjan Software Ltd., 2006.
// Greasemonkey software- Copyright 2004-2005 Aaron Boodman
// Turnabout software- Copyright 2005, Reify Software, Inc.


var TACustomSites = {
	VERSION: 3.010,

	loadSiteDefinitions: function (siteMapper) {

		/**
		 * AdsenseLinksEnhancer
		 * ====================
		 */
		var AdsenseLinksEnhancer = function() {
			this.GOOGLE_HOST_PATTERN = /^([^\/]*\.)?google\.(com|co\.\w+|com\.\w+|\w+)$/;
			this.SYNDICATION_HOST_PATTERN = /^([^\/]*\.)?googlesyndication\.com$/;
			this.SYNDICATION_AD_PATTERN = /^pagead\/.*&adurl=([^&]+)&?/;
			this.smallMode = true;
			this.smallBubble = true;

			this.extractLinkURL = function(linkElement) {
				var href = linkElement.href;
				var urlParts = this.parseURL(href);

				// IF the URL is of google ad syndication host
				if (this.hostMatches(urlParts, this.SYNDICATION_HOST_PATTERN)) {

					// Ignore 'link unit' ads
					if (this.matchPath(urlParts, /^pagead\/ads/) && ((linkElement.id == null) || (linkElement.id.length == 0)))  {
						this.smallMode = false;
						this.smallBubble = false;
						return null;
					}

					if ((linkElement.className != null) && (linkElement.className == 'adt'))  {
						this.smallMode = false;
						this.smallBubble = false;
					}

					var linkParams = {};
					// Image ads (banners) should have absolute position
					if (linkElement.firstChild && (linkElement.firstChild.nodeName == 'IMG')) {
						var pos = TACode.Utils.Element.findPosition(linkElement.parentNode);
						linkParams.imageLink = true;
						linkParams.absolutePosition = true;
						linkParams.leftPos = pos[0];
						linkParams.topPos = pos[1];
					}

					// If the URL includes an ad URL, retutn the ad URL
					return [this.matchPath(urlParts, this.SYNDICATION_AD_PATTERN), linkParams];
				}

				// Ignore internal links of google
				if (this.hostMatches(urlParts, this.GOOGLE_HOST_PATTERN)) {
					return null;
				}

				return [href, {}];
			};
		};

		/**
		 * AdsenseToolbar
		 * ==============
		 */
		AdsenseToolbar = function() {

			// Disable message notifications
			this.notifyMessage = function(messageID, messageBody, messageViewedCallback) {
					return false;
			}
		};

		siteMapper.addSiteMapping({ h: /^.*\.googlesyndication\.com$/, links: AdsenseLinksEnhancer, toolbar: AdsenseToolbar });

		/**
		 * DiggLinksEnhancer
		 * ===================
		 */
		var DiggLinksEnhancer = function() {
			this.DIGG_HOST_PATTERN = /^([^\/]*\.)?digg.com$/;
			//this.EXCLUDED_HOSTS = ["dynamic.fmpub.net", "www.jinx.com", "www.google.com", "www.federatedmedia.net", "www.revision3.com", "feeds.feedburner.com", "phobos.apple.com", "odeo.com", "creativecommons.org"];
			this.SYNDICATION_HOST_PATTERN = /^([^\/]*\.)?googlesyndication\.com$/;
			this.SYNDICATION_AD_PATTERN = /^pagead\/.*&adurl=([^&]+)&?/;
			this.REDIRECT_PATH_PATTERN1 = /^http[s]?:\/\/dads.([a-zA-Z0-9]*\.)?digg.com\/click\?/;
			this.REDIRECT_PATH_PATTERN2 = /^http[s]?:\/\/(www.)?digg.com\/story\//;  //May cause overloading
			//this.REDIRECT_PATH_PATTERN3 = /^http[s]?:\/\/(www.)?digg.com\/search\?q=site:/;
			this.smallMode = true;


			this.extractLinkURL = function(linkElement) {
				var href = linkElement.href;
				var urlParts = this.parseURL(href);
				
				if(linkElement.firstChild && (linkElement.firstChild.nodeName.toUpperCase() == "IMG" || linkElement.firstChild.nodeName.toUpperCase() == "SPAN" || linkElement.firstChild.nodeName.toUpperCase() == "DIV")){
					return;
				}

				if(linkElement.parentNode.nodeName.toUpperCase() == "P" && linkElement.parentNode.previousSibling && linkElement.parentNode.previousSibling.nodeName.toUpperCase() == "H3" && linkElement.parentNode.previousSibling.firstChild.href == href){
					return;
				}
				
				if(linkElement.parentNode.nodeName.toUpperCase() == "P" && linkElement.previousSibling && linkElement.previousSibling.nodeName.toUpperCase() == "A" && linkElement.previousSibling.firstChild.href == href){
					return;
				}

				//External redirect links
				if (href.match(this.REDIRECT_PATH_PATTERN1) || href.match(this.REDIRECT_PATH_PATTERN2)) {// || href.match(this.REDIRECT_PATH_PATTERN3)
					return [href, {}];
				}
				
				// Ignore digg internal links
				if (this.hostMatches(urlParts, this.DIGG_HOST_PATTERN)) {
					return null;
				}

				// Small links of digg articles (via http...) should not include a state icon but
				// the click should be secured
				if ((TACode.Utils.Element.getTextContent(linkElement) != null) &&
					TACode.Utils.Element.getTextContent(linkElement).match(/^via.*$/) &&
					((linkElement.className != null) && (linkElement.className == "simple tight"))) {
					return [href, {uiInvisible: true}];
				}

				// Ignore links of any of the excluded hosts
				/*for (var i=0; i < this.EXCLUDED_HOSTS.length; i++) {
					if (urlParts.host == this.EXCLUDED_HOSTS[i]) {
						return null;
					}
				}*/

				// Links in comments should include an extra line break
				if ((linkElement.parentNode.className != null) && (linkElement.parentNode.className == "c-body-inside")) {
					return [href, {extraBreak: true, smallIcon: true}];
				}

				// Extract actual ad link from integrated google syndication ads
				if (this.hostMatches(urlParts, this.SYNDICATION_HOST_PATTERN)) {
					return [this.matchPath(urlParts, this.SYNDICATION_AD_PATTERN), {smallIcon: true}];
				}

				// Ignore youtube and google video thumbnail links
				if (linkElement.className && (linkElement.className == 'thumb')) {
					return null;
				}

				return [href, {}];
			};


			this.appendStateElement = function(link) {
				// Integrated google adds that are 'big blocks' should include the state icon
				// inside the block instead of left to the block.
				if ((link.domElement.className != null) && (link.domElement.className == 'ad_block')) {
					link.stateIconElement.style.margin = "0px";
					link.domElement.firstChild.insertBefore(link.stateElement, link.domElement.firstChild.firstChild);
				} else {
					link.domElement.parentNode.insertBefore(link.stateElement, link.domElement);
				}
			};

			this.appendBeforeStateElement = function(link) {
				// Add extra line break after the state icon if needed.
				if (link.extraBreak) {
					link.stateElement.appendChild(document.createElement('br'));
				}
			};

		};
		siteMapper.addSiteMapping({ h: /^([^\/]*\.)?digg\.com$/, links: DiggLinksEnhancer });



		/**
		 * YahooLinksEnhancer
		 * ===================
		 */
		var YahooLinksEnhancer = function() {
			this.RDS_HOST_PATTERN = /^(\w\w\.wrs|rds)\.yahoo\.com$/;
			this.RDS_PATH_PATTERN = /EXP=\d+\/\*\*(http.*)$/;
			this.RDS_HOST_PATTERN2 = /^search.yahoo.com/;
			this.RDS_PATH_PATTERN2 = /_ylt=.+EXP=\d+\/\*\*(http.*)/;
			this.YAHOO_HOST_PATTERN = /^([^\/]*\.)?yahoo\.(com|co\.\w+|com\.\w+|\w+)$/;
			this.AD_RDR_HOST_PATTERN = /^rdr\w\d+\.yahoo\.com$/;
			this.AD_RDR_PATH_PATTERN = /^click\?u=([^&]+)&?/;
			this.OVERTURE_HOST_PATTERN = /overture.com$/;
			this.OVERTURE_PATH_PATTERN = /&yargs=([^&]+)&?/;
			//this.EXCLUDED_HOSTS = ["clkuk.tradedoubler.com", "clkde.tradedoubler.com"];

			this.CACHE_PATH_PATTERN = /^search\/cache/;
			this.TRANSLATION_PATH_PATTERN = /language\/translation/;

			this.extractLinkURL = function(linkElement) {
				var href = linkElement.href;

				var urlParts = this.parseURL(href);
				var childs = linkElement.childNodes;
				// Ignore links of images (there's a small icon near each search result entry)
				if (linkElement.firstChild && (linkElement.firstChild.nodeName == 'IMG')) {
					return null;
				}

				// If the URL is a Yahoo redirector, handle the inner URL
				if (this.hostMatches(urlParts, this.RDS_HOST_PATTERN)) {
					// Extract the inner redirected URL.
					var actualURL = this.matchPath(urlParts, this.RDS_PATH_PATTERN);
					var actualURLParts = this.parseURL(actualURL);

					// If the link is an ad search result, it includes another redirector
					if (this.hostMatches(actualURLParts, this.AD_RDR_HOST_PATTERN)) {
						var actualAdURL = this.matchPath(actualURLParts, this.AD_RDR_PATH_PATTERN);
						if (actualAdURL) {
							return [actualAdURL, {}];
						}
					}

					// Otherwise, handle the inner URL
					return this.extractActualYahooURL(linkElement, actualURL, actualURLParts);
				}
				
				if (this.hostMatches(urlParts, this.RDS_HOST_PATTERN2) && this.matchPath(urlParts, this.RDS_PATH_PATTERN2)) {
					
					// Extract the inner redirected URL.
					var actualURL = this.matchPath(urlParts, this.RDS_PATH_PATTERN);
					var actualURLParts = this.parseURL(actualURL);

					// If the link is an ad search result, it includes another redirector
					if (this.hostMatches(actualURLParts, this.AD_RDR_HOST_PATTERN)) {
						var actualAdURL = this.matchPath(actualURLParts, this.AD_RDR_PATH_PATTERN);
						if (actualAdURL) {
							return [actualAdURL, {}];
						}
					}

					// Otherwise, handle the inner URL
					
					return this.extractActualYahooURL(linkElement, actualURL, actualURLParts);
				}

				return this.extractActualYahooURL(linkElement, href, urlParts);
			};

			this.extractActualYahooURL = function(linkElement, url, urlParts) {

				// Handle overture ad links
				if (this.hostMatches(urlParts, this.OVERTURE_HOST_PATTERN)) {
					var actualSite = this.matchPath(urlParts, this.OVERTURE_PATH_PATTERN);
					if (actualSite == null) {
						return null;
					}

					var linkParams = {}
					if (linkElement.parentNode.nodeName == 'LI') {
							var pos = TACode.Utils.Element.findPosition(linkElement);
							linkParams.absolutePosition = true;
							linkParams.leftPos = pos[0] - 18;
							linkParams.topPos = pos[1];
					}
					return ["http://" + actualSite, linkParams];
				}

				// Ignore internal Yahoo URLs
				if (this.hostMatches(urlParts, this.YAHOO_HOST_PATTERN)) {
					return null;
				}

				// Ignore excluded hosts
				/*for (var i = 0; i < this.EXCLUDED_HOSTS.length ; i++) {
					if (urlParts.host == this.EXCLUDED_HOSTS[i]) {
						return null;
					}
				}*/
				// Ignore translation URLs that are IP based URLs with a translation path.
				if (this.isIPHost(urlParts) && (urlParts.path.match(this.TRANSLATION_PATH_PATTERN) ||
					urlParts.path.match(this.CACHE_PATH_PATTERN))) {
					return null;
				}

				return [url, {}];
			};

		};
		siteMapper.addSiteMapping({ h: /^(ca\.|uk\.|de\.|nl\.|fr\.|es\.|au\.)?search\.yahoo\.com$/, p: /^\/search/, links: YahooLinksEnhancer });


		/**
		 * LiveMailLinksEnhancer
		 * ======================
		 */

        var LiveMailLinksEnhancer = function() {
			this.LIVE_HOST_PATTERN = /live\.com$/;
			this.MSN_HOST_PATTERN = /msn\.com$/;
			this.MICROSOFT_HOST_PATTERN = /microsoft\.com$/;
			this.MSN_TRUSTED_HOSTS = [/microsoft\.com$/, /msn\.com$/, /live\.com$/, /windowsliveformobile\.com$/];//, /facebook\.com$/, /twitter\.com$/, /google\.co/
			this.MAILTO_
			this.smallMode = true;

			this.shouldReEnhanceLinks = function() {
				return true;
			};

            this.extractLinkURL = function(linkElement) {
	        	var href = linkElement.href;
                if ((href == null) || (href.length == 0) || (href == '#')) {
                    return null;
                }

				if (href.match(/^mailto:/)) {
					return null;
				}

                var urlParts = this.parseURL(href);
                // Ignore internal MSN or Line links.
				//if (this.hostMatches(urlParts, this.LIVE_HOST_PATTERN) || this.hostMatches(urlParts, this.MSN_HOST_PATTERN)) {
				//	return null;
				//}
				for (var i = 0; i < this.MSN_TRUSTED_HOSTS.length; i++) {
					if (this.hostMatches(urlParts, this.MSN_TRUSTED_HOSTS[i])) {
						return null;
					}
				}
				
				// In IE, ignore links in a composition editor (also for reply and forward).
				if (TACode.Utils.Element.isIE()) {
					var node = linkElement;
					while ((node != null) && (node.nodeNAme != 'BODY')) {
						if (node.id && node.id == 'fEditArea') {
							return null
						}
						node = node.parentNode;
					}
				}

				var linkParams = {};
				// Hide UI enhancment for image or area-map links.
				if (linkElement.nodeName == 'AREA') {
					linkParams.uiInvisible = true;
				} else {
					for (var i = 0; i < linkElement.childNodes.length; i++) {
						var node = linkElement.childNodes[i];
						if (node.nodeName == 'IMG') {
							var pos = TACode.Utils.Element.findPosition(node);
							linkParams.uiInvisible = true;
							break;
						}
					}
				}

				// To avoid validation of spam or cofirmation emails, we send only the 'host' part of the URL
				var url = urlParts.protocol + "://" + urlParts.host + urlParts.port;

                return [url, linkParams];
            };


        };

        //siteMapper.addSiteMapping({ h: /mail.live.com$/, p: /^\/mail\/ApplicationMain/, links: LiveMailLinksEnhancer });
        siteMapper.addSiteMapping({ h: /([\.a-zA-Z0-9]*)?.mail.live.com/, links: LiveMailLinksEnhancer });


		/**
		 * GoogleLinksEnhancer
		 * ===================
		 */
        var GoogleLinksEnhancer = function(managerObj) {
		    this.EXCLUDED_HOSTS=["webcache.googleusercontent.com"];//"www.orkut.com", "www.blogger.com", "blogsearch.google.com", "www.youtube.com", 
			this.GOOGLE_HOST_PATTERN = /^([^\/]*\.)?google\.(com|co\.\w+|com\.\w+|\w+)$/;
			this.INTERSTITIAL_PATH_PATTERN = /^interstitial\?url=(.+)$/;
			this.AD_PATH_PATTERN = /^pagead\/.*&adurl=([^&]+)&?/;
			this.AD_REDIRECTOR_PATH_PATTERN = /^aclk.*&ai=.*&adurl=([^&]+)&?/;
			this.GP_REDIRECT_PATH_PATTERN = /^product_url\?q=([^&]+)&?/;
			this.GENERAL_REDIRECTOR_PATH_PATTERN1 = /^url\?.+&q=([^&]+)&?/;
			this.GENERAL_REDIRECTOR_PATH_PATTERN2 = /^url\?url=(.*)/;
			this.GENERAL_REDIRECTOR_PATH_PATTERN3 = /^url\?q=(.*)/;
			this.GENERAL_REDIRECTOR_PATH_PATTERN4 = /^url\?url=(.*)(\&rct=)(.*)/;
			this.CACHE_PATH_PATTERN = /^search\?q=cache:/;
			this.FIREFOX_PAGE = /\/firefox\?.*/;
			this.LOCAL_HOSTS = [/^127.0.0.1$/, /^localhost$/];
			this.IGOOGLE_HOSTS = /^http[s]?:\/\/(www\.)?google.(com|[a-zA-Z\.]*)\/ig/;
			managerObj.pauseTimeoutVar = 500; // If we want to delay the scanning in Google, that's the place. change it to 2000 for 2 seconds
			this.extractLinkURL = function(linkElement) {
				// Ignore iGoogle
				/*if(linkElement.href.indexOf("ubuntuforums") > -1){
					debugger;
				}*/
				if (window.parent.location.href.match(this.IGOOGLE_HOSTS)) {
					return null;
				}
				
				var href = linkElement.href;
				var urlParts = this.parseURL(href);

				for (var i=0; i < this.EXCLUDED_HOSTS.length; i++) 
				{
					if (urlParts.host == this.EXCLUDED_HOSTS[i]) {
						return null;
					}
				}

				// If the URL is google internal
				if (this.hostMatches(urlParts, this.GOOGLE_HOST_PATTERN)) {

					// If the URL includes the interstitial redirector of google (dangerous site protection).
					var siteURL = this.matchPath(urlParts, this.INTERSTITIAL_PATH_PATTERN);
					if (siteURL != null) {
						return [siteURL, {}];
					}

					// If the URL includes an inner redirected ad URL, return the ad URL
					var adURL = this.matchPath(urlParts, this.AD_PATH_PATTERN);
					if (adURL != null) {
						return [adURL, {}];
					}
					// 	If the URL is a general google redirector, exract the inner url
					var innerURL = this.matchPath(urlParts, this.GENERAL_REDIRECTOR_PATH_PATTERN3);
					if (innerURL != null) {
						return [innerURL, {smallIcon: true}];
					}
					
					innerURL = this.matchPath(urlParts, this.GENERAL_REDIRECTOR_PATH_PATTERN4);
					if (innerURL != null) {
						var innerURLParts = this.parseURL(innerURL);
						for (var i=0; i < this.EXCLUDED_HOSTS.length; i++) 
						{
							if (innerURLParts.host == this.EXCLUDED_HOSTS[i]) {
								return null;
							}
						}
						return [innerURL, {smallIcon: true, overlay: false}];
					}
					
					innerURL = this.matchPath(urlParts, this.GENERAL_REDIRECTOR_PATH_PATTERN2);
					if (innerURL != null) {
						var innerURLParts = this.parseURL(innerURL);
						for (var i=0; i < this.EXCLUDED_HOSTS.length; i++) 
						{
							if (innerURLParts.host == this.EXCLUDED_HOSTS[i]) {
								return null;
							}
						}
						return [innerURL, {smallIcon: true}];
					}
					
					innerURL = this.matchPath(urlParts, this.GENERAL_REDIRECTOR_PATH_PATTERN1);
					if (innerURL != null) {
						return [innerURL, {smallIcon: true}];
					}
					
					innerURL = this.matchPath(urlParts, this.GP_REDIRECT_PATH_PATTERN);
					if (innerURL != null) {
						return [innerURL, {}];
					}
					
					// If the URL is a Google redirector, extract the inner redirected URL
					adURL = this.matchPath(urlParts, this.AD_REDIRECTOR_PATH_PATTERN);
					return [adURL, {}];
				}

				// Ignore 'cached' URLs that are IP based URLs with a cache path.
				if (this.isIPHost(urlParts) && urlParts.path.match(this.CACHE_PATH_PATTERN)) {
					return null;
				}
				
				// Ignore firefox homepage
				if (document.location.href.match(this.FIREFOX_PAGE)) {
					return null;
				}

				// Ignore local addresses of google desktop.
				for (var i = 0; i < this.LOCAL_HOSTS.length; i++ ){
					if (this.hostMatches(urlParts, this.LOCAL_HOSTS[i])) {
						return null;
					}
				}
				var firstChildObj = this.getNextElmIfType(linkElement.firstChild, "3");
				if(firstChildObj && firstChildObj.nodeName.toUpperCase() == "IMG"){
					return [href,  {smallIcon: true, overlay: true}];
				}
				return [href, {}];
			};
		};

		/**
		 * GoogleToolbar
		 * ===============
		 */
		var GoogleToolbar = function() {

		};

		siteMapper.addSiteMapping({ h: /^www\.google\.(com|co\.\w+|com\.\w+|\w+)$/, p: /^\/search/, links: GoogleLinksEnhancer, toolbar: GoogleToolbar });
		siteMapper.addSiteMapping({ h: /^www\.google\.(com|co\.\w+|com\.\w+|\w+)$/, links: GoogleLinksEnhancer});


		/**
		 * GMailLinksEnhancer
		 * ==================
		 */

        var GMailLinksEnhancer = function() {
			this.GOOGLE_HOST_PATTERN = /google.com$/;
			this.SYNDICATION_HOST_PATTERN = /^([^\/]*\.)?googlesyndication\.com$/;
			this.SYNDICATION_AD_PATTERN = /&adurl=([^&]+)&?/;
			this.smallMode = true;

			// Remove UI enhancements of all links in the document.
			this.removeEnhancements = function() {
				for (var i = 0; i < this.links.length; i++) {
					var link = this.links[i];
					if (!link.deleted) {
						if (!this.hostMatches(this.parseURL(link.domElement.href), this.SYNDICATION_HOST_PATTERN)) {
							link.domElement[this.getRandomID()] = false;
							if (link.stateElement && link.stateElement.parentNode) {
    							link.stateElement.parentNode.removeChild(link.stateElement);
    						}
   							link.deleted = true;
						}
					}
				}
			};

			this.initialize = function() {
					// Register listneners for removing UI enhancements when doing reply/forward of a mail's thread
					TACode.Utils.Event.observe(document.body, 'mousedown', this.safe(function(e) {
							var target = TACode.Utils.Event.element(e);
							if ((target && this.isReplyOrForwardElement(target)) ||
								(target.parentNode && this.isReplyOrForwardElement(target.parentNode)) ||
								(target.parentNode.parentNode && this.isReplyOrForwardElement(target.parentNode.parentNode))) {
								this.removeEnhancements();
							}
					}), true);
					 TACode.Utils.Event.observe(document, 'keypress', this.safe(function(e) {
					 		var keyCode = e.which ? e.which : e.keyCode;
							if ((keyCode == 114) || (keyCode == 102) || (keyCode == 97) || (keyCode == 65) ||
								(keyCode == 70) || (keyCode == 82)) {
								this.removeEnhancements();
							}
					}), true);
			};

			this.isReplyOrForwardElement = function(elem) {
				return elem.id && ((elem.id == 'sm_2') || (elem.id == 'sm_3') || (elem.id == 'sm_4')
								|| (elem.id == '_r_2_1') || (elem.id == 'r_3') || (elem.id == 'r_4') || (elem.id == 'ser'));
			};

			this.shouldReEnhanceLinks = function() {
				return true;
			};

            this.extractLinkURL = function(linkElement) {
	        	var href = linkElement.href;
				if (href.match(/^mailto:/)) {
					return null;
				}

                var urlParts = this.parseURL(href);
                // Ignore internal Google links
				if (this.hostMatches(urlParts, this.GOOGLE_HOST_PATTERN)) {
					return null;
				}
				
				// ignore links in mail body on edit mode. For new version
				var parNode = linkElement;
				while(parNode && parNode.nodeName.toUpperCase() != "BODY") {
					parNode = parNode.parentNode;
					if(parNode.nodeName.toUpperCase() == "BODY" && parNode.className.indexOf("editable") == 0){
						return null;
					}
				}
				
				// In IE, ignore links in a compose frame.
				if (TACode.Utils.Element.isIE() && document.body.firstChild &&
					(document.body.firstChild.nodeName == 'TABLE') &&
					document.body.firstChild.id &&
					document.body.firstChild.id == 'fc') {
					return null;
				}

				// In IE, ignore links in a composition editor (also for reply and forward).
				if (TACode.Utils.Element.isIE()) {
					var node = linkElement;
					while ((node != null) && (node.nodeNAme != 'BODY')) {
						if (node.className && node.className == 'ed') {
							return null
						}
						node = node.parentNode;
					}
				}

				// IF the URL is of google ad syndication host
				if (this.hostMatches(urlParts, this.SYNDICATION_HOST_PATTERN)) {
					// If the URL includes an ad URL, retutn the ad URL
					return [this.matchPath(urlParts, this.SYNDICATION_AD_PATTERN), {}];
				}


				var linkParams = {};
				// Handle images and area-map links.
				if (linkElement.nodeName == 'AREA') {
					if (TACode.Utils.Element.isIE()) {
						linkParams.uiInvisible = true;
					} else {
						var pos = TACode.Utils.Element.findPosition(linkElement);
						linkParams.imageLink = true;
						linkParams.absolutePosition = true;
						linkParams.leftPos = pos[0];
						linkParams.topPos = pos[1];
						if (pos[0] == 0 && pos[1] == 0) {
							linkParams.uiInvisible = true;
						}
					}
				} else {
					for (var i = 0; i < linkElement.childNodes.length; i++) {
						var node = linkElement.childNodes[i];
						if (node.nodeName == 'IMG') {
							var pos = TACode.Utils.Element.findPosition(node);
							linkParams.imageLink = true;
							//Commented by Arnon because in some cases the Absolute position causing the image to be scattered around
							//linkParams.absolutePosition = true;
							//linkParams.leftPos = pos[0];
							//linkParams.topPos = pos[1];
							if (pos[0] == 0 && pos[1] == 0) {
								linkParams.uiInvisible = true;
							}
							break;
						}
					}
				}

				// To avoid validation of spam or cofirmation emails, we send only the 'host' part of the URL
				var url = urlParts.protocol + "://" + urlParts.host + urlParts.port;

                return [url, linkParams];
            };

			this.registerSecureClick = function(link) {
				// Secure links by listening to global document events and checking
				// whether the target element is the given link element.
				if (TACode.Utils.Element.isIE()) {
					this.eventUtils.observe(document.body, 'mouseup', this.safe(
						function(event) {
							var target = TACode.Utils.Event.element(event);
							if ((target == link.domElement) || (target.parentNode && (target.parentNode == link.domElement))) {
								if (link.secureInProgress) {
									link.domElement.onclick = function (event) {};
									link.domElement.removeAttribute('onclick');
									link.domElement.removeAttribute('href');
									link.domElement.removeAttribute('target');
									return true;
								}

								var secured = !this.secureLinkClicking(event, link);
								if (secured) {

									var href = 	link.domElement.getAttribute('href');
									var linkTarget = 	link.domElement.getAttribute('target');
									var onclick = 	link.domElement.getAttribute('onclick');

									link.domElement.onclick = function (event) {};

									link.domElement.removeAttribute('onclick');
									link.domElement.removeAttribute('href');
									link.domElement.removeAttribute('target');

									link.secureInProgress = true;
									setTimeout(function() {
										link.domElement.setAttribute('href', href);
										link.domElement.setAttribute('target', linkTarget);
										link.domElement.setAttribute('onclick', onclick);
										link.secureInProgress = false;
									}, 1);

								}

								return secured;
							}
							return true;

						}), true);
				} else {
					this.eventUtils.observe(document.body, 'click', this.safe(
						function(event) {
							var target = TACode.Utils.Event.element(event);
							if ((target == link.domElement) || (target.parentNode && (target.parentNode == link.domElement))){
								return this.secureLinkClicking(event, link);
							}
							return true;
						}), true);
				}
			};

        };

        siteMapper.addSiteMapping({ h: /^mail\.google\.com$/, f: /^v\d+$/, links: GMailLinksEnhancer });
		siteMapper.addSiteMapping({ h: /^mail.google.com$/, links: GMailLinksEnhancer });

		/**
		 * YahooMailLinksEnhancer
		 * =======================
		 */

        var YahooMailLinksEnhancer = function() {
			this.YAHOO_HOST_PATTERN = /^([^\/]*\.)?yahoo\.(com|co\.\w+|com\.\w+|\w+)$/;
			this.smallMode = true;
			this.enabled = true;

            this.initialize = function() {
                // Only for firefox, if we are in the top frame, look for the 'message area' frame,
                // make it visible and reload it. This is required for solving the bug of Firefox
                // that does not run our engine for hidden frames.
                if (!TACode.Utils.Element.isIE()) {
                    var elem = TACode.Utils.Element.$('messageAreaIframe');
                    if (elem) {
                        this.enabled = false;
                        setTimeout(function() {
                                var elem = TACode.Utils.Element.$('messageAreaIframe');
                                var display = elem.style.display;
                                elem.style.display = 'inline';
                                elem.contentWindow.location.reload(false);
                            }, 1);
                    }
                }
            };

            this.shouldEnhanceLinks = function() {
                return this.enabled;
            };

			this.shouldReEnhanceLinks = function() {
				return this.enabled;// && !TACode.Utils.Element.isIE();
			};

            this.extractLinkURL = function(linkElement) {
	        	var href = linkElement.href;

				if (href.match(/^mailto:/)) {
					return null;
				}
                var urlParts = this.parseURL(href);
                // Ignore internal yahoo links
				if (this.hostMatches(urlParts, this.YAHOO_HOST_PATTERN)) {
					return null;
				}

				var linkParams = {};
				// Handle image or area-map links
				if (linkElement.nodeName == 'AREA') {
					if (TACode.Utils.Element.isIE()) {
						linkParams.uiInvisible = true;
					} else {
						var pos = TACode.Utils.Element.findPosition(linkElement);
						linkParams.imageLink = true;
						linkParams.absolutePosition = true;
						linkParams.leftPos = pos[0];
						linkParams.topPos = pos[1];
						if (pos[0] == 0 && pos[1] == 0) {
							linkParams.uiInvisible = true;
						}
					}
				} else {
					for (var i = 0; i < linkElement.childNodes.length; i++) {
						var node = linkElement.childNodes[i];
						if (node.nodeName == 'IMG') {
							var pos = TACode.Utils.Element.findPosition(node);
							linkParams.imageLink = true;
							linkParams.absolutePosition = true;
							linkParams.leftPos = pos[0];
							linkParams.topPos = pos[1];
							if (pos[0] == 0 && pos[1] == 0) {
								linkParams.uiInvisible = true;
							}
							break;
						}
					}
				}

				// To avoid validation of spam or cofirmation emails, we send only the 'host' part of the URL
				var url = urlParts.protocol + "://" + urlParts.host + urlParts.port;

                return [url, linkParams];
            };
        };

		// Site mapper of Yahoo mail for IE
        siteMapper.addSiteMapping({ h: /mail.yahoo.com$/, p:/^\/dc\/launch/, f: /^msgAreaFrame$/, links: YahooMailLinksEnhancer });

        // Site mapper of Yahoo mail for Firefox
        siteMapper.addSiteMapping({ h: /mail.yahoo.com$/, p: /^\/dc\/blank.html/, links: YahooMailLinksEnhancer });
        if (!TACode.Utils.Element.isIE()) {
            // Registering the main frame in Firefox in order to workaround the firefox problem of hidden frames
            siteMapper.addSiteMapping({ h: /mail.yahoo.com$/, p: /^\/dc\/launch/, links: YahooMailLinksEnhancer });
        }



		/**
		 * MySpaceLinksEnhancer
		 * ====================
		 */
		var MySpaceLinksEnhancer = function() {
			this.MYSPACE_HOST_PATTERN = /myspace.com$/;
			this.OVERTURE_HOST_PATTERN = /overture.com$/;
			this.OVERTURE_PATH_PATTERN = /&yargs=([^&]+)&?/;
			this.GOOGLE_HOST_PATTERN = /^([^\/]*\.)?google\.(com|co\.\w+|com\.\w+|\w+)$/;
			this.AD_PATH_PATTERN = /^pagead\/.*&adurl=([^&]+)&?/;
			this.AD_REDIRECTOR_PATH_PATTERN = /^url.*&ai=.*&q=([^&]+)&?/;
			this.PROFILEMYSPACE_HOST_PATTERN = /^.*profile.myspace.com$/;


			this.extractLinkURL = function(linkElement) {
				var href = linkElement.href;
				var urlParts = this.parseURL(href);			
				var isAbsolute = false;
				
				if(linkElement.lastChild && linkElement.lastChild.nodeName == 'IMG'){
					isAbsolute = true;
				}
				
				if((linkElement.innerText == "" || !linkElement.innerText) && !linkElement.firstChild){
					return null;
				}
				
				if (document.location.href.match(/SearchType=Classifieds/)) {
					this.smallBubble = true;
					this.smallMode = true;
				}
				if ((this.hostMatches(urlParts, this.PROFILEMYSPACE_HOST_PATTERN)) && 
					(!document.location.href.match(/searchresults.myspace.com/) )
				   )
				{
					return [href,  {smallIcon: true, overlay: isAbsolute}];
				}

				// If the URL is myspace internal
				if (this.hostMatches(urlParts, this.MYSPACE_HOST_PATTERN)) {
					return null;
				}

				if (this.hostMatches(urlParts, this.OVERTURE_HOST_PATTERN)) {
					var actualSite = this.matchPath(urlParts, this.OVERTURE_PATH_PATTERN);
					if (actualSite == null) {
						return null;
					}

					if (document.location.href.match(/searchtype=web/) && linkElement.parentNode.nodeName != 'H3') {
						return null;
					}

					return ["http://" + actualSite, {overlay: isAbsolute}];
				}

				// If the URL is google ad
				if (this.hostMatches(urlParts, this.GOOGLE_HOST_PATTERN)) {

					// If the URL includes an inner redirected ad URL, return the ad URL
					var adURL = this.matchPath(urlParts, this.AD_PATH_PATTERN);
					if (adURL != null) {
						return [adURL, { adLink: true, smallIcon: true, overlay: isAbsolute }];
					}

					// If the URL is a Google redirector, extract the inner redirected URL
					adURL = this.matchPath(urlParts, this.AD_REDIRECTOR_PATH_PATTERN);
					return [adURL, { adLink: true, smallIcon: true, overlay: isAbsolute }];
				}

				return [href, {overlay: isAbsolute}];
			};


			this.appendStateElement = function(link) {
				if (link.adLink && link.domElement.firstChild) {
					link.domElement.insertBefore(link.stateElement, link.domElement.firstChild);
				} else {
					link.domElement.parentNode.insertBefore(link.stateElement, link.domElement);
				}
			};

		};
		
		//siteMapper.addSiteMapping({ h: /^http[s]?:\/\/(www.)?myspace.com/, links: MySpaceLinksEnhancer });
		siteMapper.addSiteMapping({ h: /^([^\/]*\.)?myspace\.com$/, links: MySpaceLinksEnhancer });
		siteMapper.addSiteMapping({ h: /^searchresults.myspace.com$/, links: MySpaceLinksEnhancer });
		siteMapper.addSiteMapping({ h: /^sads.myspace.com$/, p: /^\/\/?Modules\/Search\/Pages\/Search.aspx/, links: MySpaceLinksEnhancer });



		/**
		 * BloggerLinksEnhancer
		 * ====================
		 */
		var BloggerLinksEnhancer = function() {
			this.BLOGGER_HOST_PATTERN = /blogsearch.google.com$/;
			this.GOOGLE_HOST_PATTERN = /google.com$/;

			this.extractLinkURL = function(linkElement) {
				
				if(linkElement.previousSibling && linkElement.previousSibling.nodeName == "CENTER"){
					return null;
				}
				
				var href = linkElement.href;
				var urlParts = this.parseURL(href);

				// If the URL is myspace internal
				if (this.hostMatches(urlParts, this.BLOGGER_HOST_PATTERN) || this.hostMatches(urlParts, this.GOOGLE_HOST_PATTERN)) {
					return null;
				}

				if (linkElement.parentNode && (linkElement.parentNode.nodeName == 'P') && (linkElement.parentNode.className == 'blog')) {
					return [href, {smallIcon: true}];
				}
				
				if (linkElement.lastChild && linkElement.lastChild.nodeName.toUpperCase() == 'IMG') {
					return [href, {smallIcon: true, overlay: true}];
				}

				return [href, {}];
			};
		};

		siteMapper.addSiteMapping({ h: /^blogsearch.google.com$/, links: BloggerLinksEnhancer });


		/**
		 * MSNLinksEnhancer
		 * ===================
		 */
		var MSNLinksEnhancer = function() {
			this.LIVE_HOST_PATTERN = /^.*\.live\.com$/;
			this.G_HOST_PATTERN = /^(search|g)\.(msn|live)\.com$/;
			this.G_PATH_PATTERN = /(?:url=|\/\d+\?)(http.*?)(&&|$)/;
			this.G_AD_HOST_PATTERN = /^[^.]+\.r\.msn\.com/;
			this.HOTMAIL_HOST_PATTERN = /^www\.hotmail\.com$/;
			this.MSN_HOST_PATTERN = /^([^\/]*\.)?msn\.(com|co\.\w+|com\.\w+|\w+)$/;
			this.CACHE_HOST_PATTERN = /^([^\/]*\.)?msnscache\.(com|co\.\w+|com\.\w+|\w+)$/;
			this.OVERTURE_HOST_PATTERN = /overture.com$/;
			this.OVERTURE_PATH_PATTERN = /&yargs=([^&]+)&?/;
			this.BING_HOST_PATTERN = /^.*\.bing\.com$/;
			this.MICROSOFT_HOST_PATTERN = /^.*\.microsoft\.com$/;
			this.BING_CACHE_HOST_PATTERN = /^cc\.bingj\.(com|co\.\w+|com\.\w+|\w+)$/;
			this.BING_STATIC_LINKS1 = /^ms\.ciao\.co\.uk$/;
			this.BING_STATIC_LINKS2 = /^www\.dec\.org\.uk$/;
			this.BING_STATIC_LINKS3 = /^advertising\.microsoft\.com$/;
			this.BING_STATIC_LINKS4 = /^go\.microsoft\.com$/;
			this.BING_STATIC_LINKS5 = /^www\.microsofttranslator\.com$/;

			this.extractLinkURL = function(linkElement) {
				var href = linkElement.href;
				var urlParts = this.parseURL(href);
				if(href.indexOf("abcnews.go.com") > -1){
					//debugger;
				}
				// Most MSN links are using redirectors, several times. Check if this is our case, and unwrap them.
				var innerUrlParts = null;
				if (this.hostMatches(urlParts, this.G_HOST_PATTERN) || this.hostMatches(urlParts, this.G_AD_HOST_PATTERN)) {
					innerUrlParts = urlParts;
					var i = 0;
					while (innerUrlParts != null && this.hostMatches(innerUrlParts, this.G_HOST_PATTERN)) {
						// Extract the actual URL from the redirector
						var actualURL = this.matchPath(innerUrlParts, this.G_PATH_PATTERN);
						if (actualURL != null) {
							// Parse the actual URL into URL parts.
							innerUrlParts = this.parseURL(actualURL);
						} else {
							innerUrlParts = null;
						}
						if (++i == 10) {
							throw "Too many iterations unwrapping redirector";
						}
					}

					if (innerUrlParts != null) {
						// A redirector was unwrapped
						var actualURLParts = innerUrlParts;


						// If the action url is an ad, extract the actual site's link form the html
						// content of the ad (because the site's link is not part of the link
						if (this.hostMatches(actualURLParts, this.G_AD_HOST_PATTERN)) {

	                        if (linkElement.nextSibling && TACode.Utils.Element.getTextContent(linkElement.nextSibling).match(/^ - (\w+\.)+/)) {
                                    return ["http://" + TACode.Utils.Element.getTextContent(linkElement.nextSibling).substr(3), {}];
                            } else if (linkElement.parentNode && linkElement.parentNode.nextSibling && linkElement.parentNode.nextSibling.nextSibling &&
                                           TACode.Utils.Element.getTextContent(linkElement.parentNode.nextSibling.nextSibling).match(/(\w+\.)+/)) {
	                            return ["http://" + TACode.Utils.Element.getTextContent(linkElement.parentNode.nextSibling.nextSibling), {}];
                            }
						}

						// If the actual URL is a local MSN URL, ignore it.
						if (this.hostMatches(actualURLParts, this.MSN_HOST_PATTERN)) {
							return null;
						}

						// Return the external actual URL.
						return [actualURL, {}];
					}
				}

				// Handle overture ad links
				if (this.hostMatches(urlParts, this.OVERTURE_HOST_PATTERN)) {
					var actualSite = this.matchPath(urlParts, this.OVERTURE_PATH_PATTERN);
					if (actualSite == null) {
						return null;
					}

					return ["http://" + actualSite, {}];
				}


				// Ignore links to local MSN pages and cache pages.
				if (this.hostMatches(urlParts, this.MSN_HOST_PATTERN) || 
					this.hostMatches(urlParts, this.CACHE_HOST_PATTERN) ||
					this.hostMatches(urlParts, this.BING_CACHE_HOST_PATTERN)) 
				{
					return null;
				}

				// Ignore hotmail and live links
				if (this.hostMatches(urlParts, this.HOTMAIL_HOST_PATTERN) || 
					this.hostMatches(urlParts, this.LIVE_HOST_PATTERN) ||
					this.hostMatches(urlParts, this.MICROSOFT_HOST_PATTERN) ||
					this.hostMatches(urlParts, this.BING_HOST_PATTERN)) 
				{
					return null;
				}

				// Ignore bing static links
				if (this.hostMatches(urlParts, this.BING_STATIC_LINKS1) || 
					this.hostMatches(urlParts, this.BING_STATIC_LINKS2) ||
					this.hostMatches(urlParts, this.BING_STATIC_LINKS3) ||
					this.hostMatches(urlParts, this.BING_STATIC_LINKS4) ||
					this.hostMatches(urlParts, this.BING_STATIC_LINKS5)) 
				{
					return null;
				}
				var useAbsolute = false;
				var useSmallIcon = false;
				if(linkElement.parentNode.nodeName.toUpperCase() == "SPAN" && linkElement.parentNode.parentNode.nodeName.toUpperCase() == "SPAN" && linkElement.parentNode.parentNode.className == "rowvideo"){
					useAbsolute = true;
					return null;
				}
				return [href, {smallIcon: useSmallIcon, overlay: useAbsolute}];

			};

		};
		siteMapper.addSiteMapping({ h: /^search\.live\.com$/, p: /^\/results/, links: MSNLinksEnhancer });
		siteMapper.addSiteMapping({ h: /^www\.bing\.com$/, links: MSNLinksEnhancer });


		/* ProfileMySpaceLinksEnhancer
		 * ===========================
		 */

		var profileMySpaceLinksEnhancer = function() {

			this.PROFILEMYSPACE_HOST_PATTERN = /^.*profile.myspace.com$/;
			
			this.extractLinkURL = function(linkElement)
			{
				var href = linkElement.href;
				var urlParts = this.parseURL(href);
				
				href = href.replace(/\r/,"");
				href = href.replace(/\n/,"");
                                href = href.replace(/%0A/,"");
                                href = href.replace(/%0D/,"");

				if ((this.hostMatches(urlParts, this.PROFILEMYSPACE_HOST_PATTERN)) && 
					(!document.location.href.match(/searchresults.myspace.com/) )
				   )
				{
					return [href,  {smallIcon: true}];
				}
				return null;
			};
		};

		siteMapper.addSiteMapping({ h: /^.*.myspace.com$/, links: profileMySpaceLinksEnhancer });

		/**
		 * twitter
		 * ===================
		 */
		
		var TwitterSearchEnhancer = function() {
			this.TWITTER_HOST_PATTERN = /twitter.com$/;
			this.TWITTER_HOSTS = /twitter.com/;
			this.TWITTER_TRASTED_HOSTS = [/twitter.threadless.com/];/// , /wefollow.com/, /www.twitzap.com/, /www.tweetdeck.com/, buzz.trazzler.com/, 
			
			this.extractLinkURL = function(linkElement) {
				
				// URLs of known and legitimate Twitter applications
				if(linkElement.parentNode.parentNode.className == "meta entry-meta"){
					return null;
				}
				
				var href = linkElement.href;
				var urlParts = this.parseURL(href);
				
				if (this.hostMatches(urlParts, this.TWITTER_HOST_PATTERN)) {
					return null;
				}
				
				// trusted urls
				for (var i = 0; i < this.TWITTER_TRASTED_HOSTS.length; i++) {
					if (this.hostMatches(urlParts, this.TWITTER_TRASTED_HOSTS[i])) {
						return null;
					}
				}

				return [href,  {}];
			};
		};
		
		siteMapper.addSiteMapping({ h: /twitter.com$/, links: TwitterSearchEnhancer });
		
		/**
		 * Facebook
		 * ===================
		 */
		
		var FacebookSearchEnhancer = function() {
			this.FACEBOOK_HOST = /facebook.com$/;
			this.AD_REDIRECTOR_PATH_PATTERN = /^ajax\/emu\/end\.php\?eid=([^&]+)&?/;
			//this.FACEBOOK_TRASTED_HOSTS = [/^([^\/]*\.)?youtube.com/, /^([^\/]*\.)?twitter.com/];	
			this.FACEBOOK_APPS_HOST = /^apps.facebook.com/;
			this.FACEBOOK_APPS_PATH = /^(.+)ref=(.+)/;
			
			this.shouldReEnhanceLinks = function() {
				return true;
			};
			
			this.extractLinkURL = function(linkElement) {
							
				if((linkElement.innerText == "" || !linkElement.innerText) && !linkElement.firstChild){
					return null;
				}
				
				var href = linkElement.href;
				var urlParts = this.parseURL(href);				
				var useAbsolute = false;
				var useSmallIcon = false;
				var firstChildObj = this.getNextElmIfType(linkElement.firstChild, "3");
				
				if((document.location.href + "#") == href){
					return null;
				}
				
				if(this.matchPath(urlParts, this.AD_REDIRECTOR_PATH_PATTERN)){
					if(linkElement.parentNode && linkElement.parentNode.nodeName.toUpperCase() == "DIV" && linkElement.parentNode.className != "title"){// && linkElement.parentNode.className != "adInfo"
						return null;
					}
					useAbsolute = true;
					useSmallIcon = true;
					linkElement.style.paddingLeft = "12px";
					return [href,  {smallIcon: useSmallIcon, overlay: useAbsolute}];
				}
				
				/* skip scanning Facebook apps
				 if (this.hostMatches(urlParts, this.FACEBOOK_APPS_HOST) && this.matchPath(urlParts, this.FACEBOOK_APPS_PATH)) {
					useAbsolute = true;
					useSmallIcon = true;
					linkElement.style.marginLeft = "12px";
					return [href,  {smallIcon: useSmallIcon, overlay: useAbsolute}];
				}*/
				
				if (this.hostMatches(urlParts, this.FACEBOOK_HOST)) {
					return null;
				}
				
				// trusted urls
				/*for (var i = 0; i < this.FACEBOOK_TRASTED_HOSTS.length; i++) {
					if (this.hostMatches(urlParts, this.FACEBOOK_TRASTED_HOSTS[i])) {
						return null;
					}
				}*/
				
				if(firstChildObj && firstChildObj.nodeName.toUpperCase() == "IMG"){
					if(linkElement.parentNode && linkElement.parentNode.nodeName.toUpperCase() == "DIV" && this.trimText(linkElement.parentNode.className) == "UIMediaItem"){
						var imagDiv = linkElement.parentNode;
						if(this.trimText(imagDiv.parentNode.nextSibling.className) == "UIStoryAttachment_Info" && imagDiv.parentNode.nextSibling.firstChild.lastChild.href == href){
							return null;
						}
					}
					useAbsolute = true;
					useSmallIcon = true;
				}
				
				return [href,  {smallIcon: useSmallIcon, overlay: useAbsolute}];
			};
		};
		
		siteMapper.addSiteMapping({ h: /([\.a-zA-Z0-9]*)facebook.com/, links: FacebookSearchEnhancer });
		
		/**
		 * Linkedin
		 * ===================
		 */
		
		var LinkedinSearchEnhancer = function() {
			this.LINKEDIN_HOST = /linkedin(.*).com$/;
			this.AD_REDIRECTOR_PATH_PATTERN = /^csp\/crd\?(.*)/;
			this.APP_PATH_PATTERN = /^osview\/canvas\?(.*)/;
			this.EXTERNAL_ARTICLE_PATH_PATTERN = /^news\?viewArticle=(.*)\&articleID(.*)\&articleURL=(.+)&urlhash=(.*)/;
			this.GENERAL_REDIRECTOR_PATH_PATTERN =  /^redirect\?url=(.*?)(&urlhash=|$)/;
			this.LINKEDIN_TRUSTED_HOSTS = [/^([^\/]*\.)?linkedin.com/, /^linkedin\.(.+)\.com/];	///^([^\/]*\.)?youtube.com/, /^([^\/]*\.)?twitter.com/, 
			
			this.shouldReEnhanceLinks = function() {
				return true;
			};
			
			this.extractLinkURL = function(linkElement) {
							
				if((linkElement.innerText == "" || !linkElement.innerText) && !linkElement.firstChild){
					return null;
				}
				
				var href = linkElement.href;
				var urlParts = this.parseURL(href);				
				var useAbsolute = false;
				var useSmallIcon = false;
				var useMarginLeft = false;
				var firstChildObj = this.getNextElmIfType(linkElement.firstChild, "3");

				if(this.matchPath(urlParts, this.AD_REDIRECTOR_PATH_PATTERN)){
					//if(linkElement.parentNode.nodeName.toUpperCase() == "P" || (firstChildObj && firstChildObj.nodeName.toUpperCase() == "IMG")){
					if(firstChildObj && firstChildObj.nodeName.toUpperCase() == "IMG"){
						return null;
					}
					
					//useAbsolute = true;
					useSmallIcon = true;
					//useMarginLeft = '-11px';

					/*if(linkElement.parentNode.nodeName.toUpperCase() == "B"){
						var tempParentNode = linkElement.parentNode;
						while(tempParentNode.nodeName.toUpperCase() != "DIV" && tempParentNode.parentNode.nodeName.toUpperCase() != "BODY"){
							var parentNodeObj = tempParentNode.parentNode;
							var parentNodeClass = parentNodeObj.className;
							if(parentNodeObj.nodeName.toUpperCase() == "DIV" && parentNodeClass != "" && parentNodeClass.indexOf("ad-hdr") == 0){
								useAbsolute = false;
								useMarginLeft = false;
								break;
							}
							tempParentNode = tempParentNode.parentNode;
						}
					}*/
					linkElement.style.display = "inline";
					return [href,  {smallIcon: useSmallIcon, overlay: useAbsolute, marginLeft: useMarginLeft}];
				}
				
				if(this.matchPath(urlParts, this.APP_PATH_PATTERN) && linkElement.hash == ""){
					useAbsolute = true;
					useSmallIcon = true;
					useMarginLeft = '-10px';
					linkElement.style.marginLeft = "12px";
					return [href,  {smallIcon: useSmallIcon, overlay: useAbsolute, marginLeft: useMarginLeft}];
				}
				
				if (this.hostMatches(urlParts, this.LINKEDIN_HOST)) {
					var externalLinkResults = this.EXTERNAL_ARTICLE_PATH_PATTERN.exec(urlParts.path);
					if (externalLinkResults && externalLinkResults[3]) {
						return [unescape(externalLinkResults[3]), {}];
					}
					var redirectURL = this.matchPath(urlParts, this.GENERAL_REDIRECTOR_PATH_PATTERN);
					if (redirectURL != null) {
						var redirectURLParts =  this.parseURL(redirectURL);
						if(redirectURLParts.host == ""){
							redirectURLParts.host = redirectURL.substr(7, redirectURL.indexOf(".com")-3);
						}
						for (var i = 0; i < this.LINKEDIN_TRUSTED_HOSTS.length; i++) {
							if (this.hostMatches(redirectURLParts, this.LINKEDIN_TRUSTED_HOSTS[i])) {
								return null;
							}
						}
						return [redirectURL, {smallIcon: true}];
					}
					return null;
				}
				return [href,  {smallIcon: useSmallIcon, overlay: useAbsolute}];
			};
		};
		
		siteMapper.addSiteMapping({ h: /([\.a-zA-Z0-9]*)linkedin.com/, links: LinkedinSearchEnhancer });
    }

};

TACustomSites;

// VALIDITY_FOOTER

