
// Copyright, Finjan Software Ltd., 2006.
// Greasemonkey software- Copyright 2004-2005 Aaron Boodman
// Turnabout software- Copyright 2005, Reify Software, Inc.

var TABootstrapCode = {
	VERSION: 3.010,

	d: function(message) {
		if (GM_getValue('logger.debug', false)) {
			GM_log("DEBUG: " + message);
		}
	},

	i: function(message) {
		if (GM_getValue('logger.debug', false)) {
			GM_log("INFO: " + message);
		}
	},

	Bootstrap: function() {
		this.app = null;
		this.custom = null;
		this.appManager = null;
		this.updateCheckingInterval = GM_getValue('intervals.modulesUpdate', 24*60*60);
		this.moduleUpdateURL = GM_getValue('urls.update', 'https://securebrowsing.m86security.com/update/check_latest');

		this.defaultRelevantLocations =
			[ { h: /.*/ }
			];

		this.start = function(isStatic) {
			if (isStatic) {
				var bootstrap = this.loadUpdatedBootstrap();
				if (bootstrap) {
					bootstrap.start(false);
					return;
				}
			}

			this.d("Bootstrap version: " + TABootstrapCode.VERSION);
			setTimeout(this.safe(this.checkForUpdates), GM_getValue("update.checkDelay", 1500));

			if (this.isSiteRelevant() || this.isDomainRelevant()) {
				this.d("Site " + document.location + " is relevant ");
				this.loadApp();
				this.loadCustom();
				
    			this.appManager = new this.app.Manager();
				if (this.appManager.init(document.location, this.custom)) {
					//alert(this.appManager.pauseTimeoutVar);
					this.appManager.start();
				}
			} else {
					this.d("Site " + document.location + " is not irrelevant ");
			}

		};

		this.loadUpdatedBootstrap = function() {
			var storedBootstrap = this.loadModule('bootstrap');
			if (storedBootstrap != null) {
				if (storedBootstrap.VERSION > TABootstrapCode.VERSION) {
					TABootstrapCode = storedBootstrap;
					if (GM_getValue("scriptsVersion","0.001")<storedBootstrap.VERSION) {
						GM_setValue("scriptsVersion",""+storedBootstrap.VERSION);
					}
					return new storedBootstrap.Bootstrap();
				}
			}
			return null;
		};

		this.loadApp = function() {
			if (typeof(TACode) == 'undefined') {
				TACode = { VERSION: 0.0 };
			}
			this.app = TACode;
			var storedCode = this.loadModule('app');
			if (storedCode != null) {
				if (storedCode.VERSION == 0.001 // 0.001 = always run
				    || storedCode.VERSION > TACode.VERSION) {
					TACode = storedCode;
					if (GM_getValue("scriptsVersion","0.001")<storedCode.VERSION) {
						GM_setValue("scriptsVersion",""+storedCode.VERSION);
					}
					this.app = storedCode;
				}
			}
			this.d("App version: " + this.app.VERSION);
		};

		this.loadCustom = function() {
			if (typeof(TACustomSites) == 'undefined') {
				TACustomSites = { VERSION: 0.0 };
			}
			this.custom = TACustomSites;
			var storedCode = this.loadModule('custom');
			if (storedCode != null) {
				if (storedCode.VERSION == 0.001 // 0.001 = always run
				    || storedCode.VERSION > TACustomSites.VERSION) {
					TACustomSites = storedCode;
					if (GM_getValue("scriptsVersion","0.001")<storedCode.VERSION) {
						GM_setValue("scriptsVersion",""+storedCode.VERSION);
					}
					this.custom = storedCode;
				}
			}
			this.d("Custom sites version: " + this.custom.VERSION);
		};
		
		this.isSiteRelevant = function() {

			var relevantLocations = this.defaultRelevantLocations;

			// Load stored relevant locations
			var storedRelevantLocationsStr = GM_getValue('bootstrap.relevantLocations', null);
			if (storedRelevantLocationsStr) {
				try {
					relevantLocations = eval("(" + storedRelevantLocationsStr + ")");
				} catch (e) {
					this.d("Invalid stored relevant locations: " + e);
				}
			}

			for (var i=0; i < relevantLocations.length; i++) {
				var relevantLocation = relevantLocations[i];
				if (relevantLocation.h) {
					if (!document.location.hostname.match(this.toRegExp(relevantLocation.h))) {
						continue;
					}
				}
				if (relevantLocation.p) {
					if (!document.location.pathname.match(this.toRegExp(relevantLocation.p))) {
						continue;
					}
				}
				if (relevantLocation.f) {
					if (!window.name || !window.name.match(this.toRegExp(relevantLocation.f))) {
						continue;
					}
				}

				return true;
			}
			return false;
		};
		
		this.isDomainRelevant = function() {
			
			if(!document.domain || document.domain == ""){//this.isIE() || document.location.hostname != "" || 
				return false;
			}
			
			this.DOMAINS=[/([\.a-zA-Z0-9]*)?.mail.live.com/, /mail.yahoo.com$/];
			
			for (var i=0; i < this.DOMAINS.length; i++) 
			{
				if (document.domain.match(this.DOMAINS[i])) {
					return true;
				}
			}
			return false;
		};

		this.toRegExp = function(obj) {
			if (typeof(obj) == 'string') {
				return eval(obj);
			} else {
				return obj;
			}
		};
		
		this.checkForUpdates = function() {
			if (GM_getValue('update.extra', "") == "" // <-- always update
                && !this.isPeriodicExecutionRequired('checkForUpdates', this.updateCheckingInterval)) {
				return;
			}

			this.loadApp();
			this.loadCustom();

			var modules = [ { name: 'app', code: TACode },
							{ name: 'bootstrap', code: TABootstrapCode },
							{ name: 'custom', code: TACustomSites }
						  ];

			var browser = this.detectBrowser();
			var standardParams = { platform: browser.platform, browser: browser.agent,
			                       browserVersion: browser.agentVersion,
			                       random: Math.random(), // anti-caching (XMLHttp caches GET requests)
			                       extra: GM_getValue('update.extra', "")
			                     };

			var standardParamString = ""
			var sep = "";


			for (var oneParam in standardParams) {
				if( (oneParam=="platform") || 
				    (oneParam=="browser") || 
				    (oneParam=="browserVersion") || 
				    (oneParam=="random") || 
				    (oneParam=="extra"))
				{
					standardParamString += sep + oneParam + "=" + encodeURIComponent(standardParams[oneParam]);
					sep = "&";
				}
			}

			for (var i = 0; i < modules.length; i++) {
				var module = modules[i];
                this.checkForModuleUpdate(standardParamString, module);
            }
        }

        this.checkForModuleUpdate = function(standardParamString, module) {
			var fullURL = this.moduleUpdateURL + '?module=' + module.name + "&version=" + Math.round(module.code.VERSION*1000)/1000;
			fullURL += "&" + standardParamString;
			this.d("Module updating URL: " + fullURL);

			GM_xmlhttpRequest({
					  method:"GET",
					  url: fullURL,
					  onload:this.safe(function(details) {
						if (details.status == 200) {
							if (details.responseText.indexOf('VALIDITY_FOOTER') != -1) {
								try {
									eval("function taTest() {\n" + details.responseText + "\n}");
									this.saveModule(module.name, details.responseText);
									this.i("Saved update for: " + module.name);
									// Clear the cached locations value when a version is updated
									GM_setValue('bootstrap.relevantLocations', "");
								} catch (e) {
									this.i("Invalid module downloaded for " + module.name + ": " + e);
								}
							} else {
								this.i("Invalid module downloaded: (missing footer)");
							}
					    } else if (details.status == 304) {
					        // 304 Not Modified == no new version, so ignore silently
                            this.d("No new version for module " + module.name);
						} else {
							this.i("Error in downloading module '" + module.name + "'. status=" + details.status + "," + details.statusText);
							return;
						}
					  }),
					  onerror:this.safe(function(details) {
	                    if (details.status == 304) {
                            // 304 Not Modified == no new version, so ignore silently
                            this.d("No new version for module " + module.name);
                        } else {
							this.i("Error in downloading module '" + module.name + "' from . status=" + details.status + "," + details.statusText);
                        }
					  })
					 });
		}

		this.detectBrowser = function() {

			var BrowserDetect = {
				init: function () {
					this.browser = this.searchString(this.dataBrowser) || "An unknown browser";
					this.version = this.searchVersion(navigator.userAgent)
						|| this.searchVersion(navigator.appVersion)
						|| "an unknown version";
					this.OS = this.searchString(this.dataOS) || "an unknown OS";
				},
				searchString: function (data) {
					for (var i=0;i<data.length;i++)	{
						var dataString = data[i].string;
						var dataProp = data[i].prop;
						this.versionSearchString = data[i].versionSearch || data[i].identity;
						if (dataString) {
							if (dataString.indexOf(data[i].subString) != -1)
								return data[i].identity;
						}
						else if (dataProp)
							return data[i].identity;
					}
				},
				searchVersion: function (dataString) {
					var index = dataString.indexOf(this.versionSearchString);
					if (index == -1) return;
					return dataString.substring(index+this.versionSearchString.length+1);
				},
				dataBrowser: [
					{
						string: navigator.userAgent,
						subString: "Firefox",
						identity: "Firefox"
					},
					{		// for newer Netscapes (6+)
						string: navigator.userAgent,
						subString: "Netscape",
						identity: "Netscape"
					},
					{
						string: navigator.userAgent,
						subString: "MSIE",
						identity: "Explorer",
						versionSearch: "MSIE"
					},
					{
						string: navigator.userAgent,
						subString: "Gecko",
						identity: "Mozilla",
						versionSearch: "rv"
					},
					{ 		// for older Netscapes (4-)
						string: navigator.userAgent,
						subString: "Mozilla",
						identity: "Netscape",
						versionSearch: "Mozilla"
					}
				],
				dataOS : [
					{
						string: navigator.platform,
						subString: "Win",
						identity: "Windows"
					},
					{
						string: navigator.platform,
						subString: "Mac",
						identity: "Mac"
					},
					{
						string: navigator.platform,
						subString: "Linux",
						identity: "Linux"
					}
				]

			};
			BrowserDetect.init();

			return {agent: BrowserDetect.browser, platform: BrowserDetect.OS, agentVersion: BrowserDetect.version};
		};

		this.isPeriodicExecutionRequired = function(timeKey, expirationPeriod) {
			var currentTime = (new Date()).getTime() / 1000;
			var fullKey = 'times.' + timeKey;
			var lastTimeStr = GM_getValue(fullKey);
			var lastTime = parseInt(lastTimeStr);
			if ((!lastTime) ||
			    ((currentTime - lastTime) > expirationPeriod)) {
				GM_setValue(fullKey, "" + currentTime);
				return true;
			}
			return false;
		};

		this.saveModule = function(moduleName, moduleStr) {
			GM_setValue('modules.' + moduleName, moduleStr);
		};

		this.loadModule = function(moduleName) {
			var moduleStr = GM_getValue('modules.' + moduleName, null);
			if (moduleStr == null) {
			    return null;
			}
			try {
				var moduleValue = eval(moduleStr);
				if (moduleValue == null || moduleValue.VERSION == null) {
					return null;
				}
				return moduleValue;
			} catch (e) {
			    this.i("Exception loading module " + moduleName + ": " + e);
				return null;
			}
		};

		this.safe = function(f) {
		     var thisObject = this;
		     return function() {
		       try {
			       var args2 = [];
			       for (var i = 0; i < arguments.length; i++) {
				  args2.push(arguments[i]);
			       }
			       return f.apply(thisObject, args2);
		       } catch (e) {
					if (GM_getValue('logger.debug', false)) {
			 			GM_log("Safe catch: " + e);
					}
		       }
		     };
		 };

		this.d = function(message) {
			if (GM_getValue('logger.debug', false)) {
				GM_log("DEBUG: " + message);
			}
		};

		this.i = function(message) {
			if (GM_getValue('logger.debug', false)) {
				GM_log("INFO: " + message);
			}
		};

	}
};
TABootstrapCode;

// VALIDITY_FOOTER


(function() 
{
    if (GM_getValue('logger.debug', false)) {
	    GM_log("Initializing Secure Browsing!");
    }
    try 
    {
	    var bootstrap = new TABootstrapCode.Bootstrap();
	    bootstrap.start(true);
    } 
    catch (e) {
        GM_log("Global catch: " + e);
        for (x in e) {	GM_log(x + ": " + x[e]); }
    }

})();

